Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jboss.remoting
Class MicroRemoteClientInvoker

    java.lang.Object
      org.jboss.remoting.AbstractInvoker
          org.jboss.remoting.MicroRemoteClientInvoker

All Implemented Interfaces:
  Invoker, ClientInvoker

Direct Known Subclasses:
  RemoteClientInvoker

    public abstract class MicroRemoteClientInvoker

extends AbstractInvoker
implements ClientInvoker

MicroRemoteClientInvoker is an abstract client part handler that implements the bulk of the heavy lifting to process a remote method and dispatch it to a remote ServerInvoker and handle the result.

Specialized Client/Server Invokers might add additional functionality as part of the invocation - such as delivering queued notifcations from a remote server by adding the notification objects during each invocation to the invocation result payload and then having the client re-dispatch the notifications locally upon receiving the return invocation result. The reason for the name micro is that this class contains only api that can be run within a J2ME envrionment.

Version:
  $Revision: 3504 $
Author:
  Jeff Haynie, Tom Elrod

Nested Class Summary

Nested classes/interfaces inherited from class org.jboss.remoting.AbstractInvoker
`AbstractInvoker.CallbackLocatorHolder`

Field Summary
`protected boolean` | `connected`

Fields inherited from class org.jboss.remoting.AbstractInvoker
`classbyteloader, configuration, localServerLocators, locator, serializationType, socketFactory, socketFactoryCreatedFromSSLParameters`

Constructor Summary
`MicroRemoteClientInvoker(InvokerLocator locator)`
`MicroRemoteClientInvoker(InvokerLocator locator, java.util.Map configuration)`

Method Summary
`void` | `connect()` Connect to the remote invoker.
`void` | `disconnect()` disconnect from the remote invokere
`void` | `establishLease(java.lang.String clientSessionID, java.util.Map configuration, long leasePeriod)`
`protected void` | `finalize()` Called by the garbage collector on an object when garbage collection determines that there are no more references to the object.
`protected abstract java.lang.String` | `getDefaultDataType()` Each implementation of the remote client invoker should have a default data type that is uses in the case it is not specified in the invoker locator uri.
`long` | `getLeasePeriod(java.lang.String sessionID)`
`Marshaller` | `getMarshaller()`
`java.lang.String` | `getSessionId()`
`UnMarshaller` | `getUnMarshaller()`
`protected abstract void` | `handleConnect()` Subclasses must implement this method to provide a hook to connect to the remote server, if this applies to the specific transport.
`protected abstract void` | `handleDisconnect()` Subclasses must implement this method to provide a hook to disconnect from the remote server, if this applies to the specific transport.
`java.lang.Object` | `invoke(InvocationRequest invocationReq)` Transport a request against a remote ServerInvoker.
`boolean` | `isConnected()` Subclasses must provide this method to return true if their remote connection is connected and false if disconnected.
`protected void` | `postProcess(java.lang.String sessionId, java.lang.Object param, java.util.Map sendPayload, java.util.Map receivedPayload)` this method is called prior to returning the result for the invocation to allow the subclass the ability to modify the result result
`protected void` | `preProcess(java.lang.String sessionId, java.lang.Object param, java.util.Map sendPayload, java.util.Map receivedPayload)` this method is called prior to making the remote invocation to allow the subclass the ability to provide additional data or modify the invocation
`void` | `setMarshaller(Marshaller marshaller)`
`void` | `setUnMarshaller(UnMarshaller unmarshaller)`
`void` | `terminateLease(java.lang.String sessionId, int disconnectTimeout)` Must behave as a noop if there's no active lease.
`protected abstract java.lang.Object` | `transport(java.lang.String sessionId, java.lang.Object invocation, java.util.Map metadata, Marshaller marshaller, UnMarshaller unmarshaller)`

Methods inherited from class org.jboss.remoting.AbstractInvoker
`addClientLocator, createSocketFactory, getClassLoader, getClientLocator, getClientLocators, getLocator, getSerializationType, getSocketFactory, isCompleteSocketFactory, isSocketFactoryCreatedFromSSLParameters, needsCustomSSLConfiguration, setClassLoader, setSerializationType, setSocketFactory, wrapSocketFactory`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.jboss.remoting.transport.ClientInvoker
`addClientLocator, getClientLocator, getClientLocators, getSocketFactory, setSocketFactory`

Methods inherited from interface org.jboss.remoting.Invoker
`getLocator`

Field Detail

### connected

    protected boolean connected

Constructor Detail

### MicroRemoteClientInvoker

    public MicroRemoteClientInvoker(InvokerLocator locator)

### MicroRemoteClientInvoker

    public MicroRemoteClientInvoker(InvokerLocator locator,
                                    java.util.Map configuration)

Method Detail

### invoke

    public java.lang.Object invoke(InvocationRequest invocationReq)
                            throws java.lang.Throwable

  Transport a request against a remote ServerInvoker.

  Specified by:
    `invoke` in interface `ClientInvoker`
  Throws:
    `java.lang.Throwable`

### preProcess

    protected void preProcess(java.lang.String sessionId,
                              java.lang.Object param,
                              java.util.Map sendPayload,
                              java.util.Map receivedPayload)

  this method is called prior to making the remote invocation to allow the subclass the ability to provide additional data or modify the invocation

  Parameters:
    `sessionId` -
    `param` -
    `sendPayload` -
    `receivedPayload` -

### postProcess

    protected void postProcess(java.lang.String sessionId,
                               java.lang.Object param,
                               java.util.Map sendPayload,
                               java.util.Map receivedPayload)

  this method is called prior to returning the result for the invocation to allow the subclass the ability to modify the result result

  Parameters:
    `sessionId` -
    `param` -
    `sendPayload` -
    `receivedPayload` -

### transport

    protected abstract java.lang.Object transport(java.lang.String sessionId,
                                                  java.lang.Object invocation,
                                                  java.util.Map metadata,
                                                  Marshaller marshaller,
                                                  UnMarshaller unmarshaller)
                                           throws java.io.IOException,
                                                  ConnectionFailedException,
                                                  java.lang.ClassNotFoundException

  Throws:
    `java.io.IOException`
    `ConnectionFailedException`
    `java.lang.ClassNotFoundException`

### isConnected

    public boolean isConnected()

  Subclasses must provide this method to return true if their remote connection is connected and false if disconnected. in some transports, such as SOAP, this method may always return true, since the remote connectivity is done on demand and not kept persistent like other transports (such as socket-based transport).

  Specified by:
    `isConnected` in interface `ClientInvoker`
  Returns:
    boolean true if connected, false if not

### connect

    public void connect()
                 throws ConnectionFailedException

  Connect to the remote invoker.

  Specified by:
    `connect` in interface `ClientInvoker`
  Throws:
    `ConnectionFailedException`

### handleConnect

    protected abstract void handleConnect()
                                   throws ConnectionFailedException

  Subclasses must implement this method to provide a hook to connect to the remote server, if this applies to the specific transport. However, in some transport implementations, this may not make must difference since the connection is not persistent among invocations, such as SOAP. In these cases, the method should silently return without any processing.

  Throws:
    `ConnectionFailedException`

### handleDisconnect

    protected abstract void handleDisconnect()

  Subclasses must implement this method to provide a hook to disconnect from the remote server, if this applies to the specific transport. However, in some transport implementations, this may not make must difference since the connection is not persistent among invocations, such as SOAP. In these cases, the method should silently return without any processing.

### disconnect

    public void disconnect()

  disconnect from the remote invokere

  Specified by:
    `disconnect` in interface `ClientInvoker`

### setMarshaller

    public void setMarshaller(Marshaller marshaller)

  Specified by:
    `setMarshaller` in interface `ClientInvoker`

### getMarshaller

    public Marshaller getMarshaller()

  Specified by:
    `getMarshaller` in interface `ClientInvoker`

### setUnMarshaller

    public void setUnMarshaller(UnMarshaller unmarshaller)

  Specified by:
    `setUnMarshaller` in interface `ClientInvoker`

### getUnMarshaller

    public UnMarshaller getUnMarshaller()

  Specified by:
    `getUnMarshaller` in interface `ClientInvoker`

### getSessionId

    public java.lang.String getSessionId()

### terminateLease

    public void terminateLease(java.lang.String sessionId,
                               int disconnectTimeout)

  Description copied from interface: `ClientInvoker`
  Must behave as a noop if there's no active lease.

  Specified by:
    `terminateLease` in interface `ClientInvoker`

### getLeasePeriod

    public long getLeasePeriod(java.lang.String sessionID)

  Specified by:
    `getLeasePeriod` in interface `ClientInvoker`
  Returns:
    the lease period (in ms) if the client has an active leasing mechanism with the server or -1 otherwise.

### establishLease

    public void establishLease(java.lang.String clientSessionID,
                               java.util.Map configuration,
                               long leasePeriod)
                        throws java.lang.Throwable

  Specified by:
    `establishLease` in interface `ClientInvoker`
  Throws:
    `java.lang.Throwable`

### getDefaultDataType

    protected abstract java.lang.String getDefaultDataType()

  Each implementation of the remote client invoker should have a default data type that is uses in the case it is not specified in the invoker locator uri.

### finalize

    protected void finalize()
                     throws java.lang.Throwable

  Called by the garbage collector on an object when garbage collection determines that there are no more references to the object. A subclass overrides the `finalize` method to dispose of system resources or to perform other cleanup.

  The general contract of `finalize` is that it is invoked if and when the JavaTM virtual machine has determined that there is no longer any means by which this object can be accessed by any thread that has not yet died, except as a result of an action taken by the finalization of some other object or class which is ready to be finalized. The `finalize` method may take any action, including making this object available again to other threads; the usual purpose of `finalize`, however, is to perform cleanup actions before the object is irrevocably discarded. For example, the finalize method for an object that represents an input/output connection might perform explicit I/O transactions to break the connection before the object is permanently discarded.

  The `finalize` method of class `Object` performs no special action; it simply returns normally. Subclasses of `Object` may override this definition.

  The Java programming language does not guarantee which thread will transport the `finalize` method for any given object. It is guaranteed, however, that the thread that invokes finalize will not be holding any user-visible synchronization locks when finalize is invoked. If an uncaught exception is thrown by the finalize method, the exception is ignored and finalization of that object terminates.

  After the `finalize` method has been invoked for an object, no further action is taken until the Java virtual machine has again determined that there is no longer any means by which this object can be accessed by any thread that has not yet died, including possible actions by other objects or classes which are ready to be finalized, at which point the object may be discarded.

  The `finalize` method is never invoked more than once by a Java virtual machine for any given object.

  Any exception thrown by the `finalize` method causes the finalization of this object to be halted, but is otherwise ignored.

  Overrides:
    `finalize` in class `java.lang.Object`
  Throws:
    `java.lang.Throwable` - the `Exception` raised by this method

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright ? 1998-2005 JBoss Inc . All Rights Reserved.